require 'tempfile'
require 'json'
require "rubygems"

def msg(title, &block)
  puts "\n" + '-' * 10 + title + '-' * 10
  yield
  puts '-' * 10 + '-------' + '-' * 10 + "\n"
  sleep 1
end

# def print_usage
#   puts <<EOF
#
#   Usage: Ifd_Automation <command-name> [parameters] [options]
#
#   <command-name> can be one of
#     help
#       prints more detailed help information.
#     gen
#       generate a features folder structure.
#     version
#       prints the gem version
#     ls
#       list all steps name of Ifd Automation framework
#   <options> can be
#      -v, --verbose   Turns on verbose logging
# EOF
# end

def print_help
  puts <<EOF
  Author: INFODation company

  Usage: Ifd_Automation <command-name> [parameters] [options]

  <command-name> can be one of
    help
    gen
    version
    ls

    Commands:
      help : prints more detailed help information.

      gen  : creates a features dir. This is usually used once when
             setting up ifd-automation to ensure that the features folder contains
             the right step definitions and environment to run with cucumber.

      version : prints the gem version

      ls: list all steps name of Ifd Automation framework

  <Options>
      -v, --verbose  Turns on verbose logging
EOF
end