#Assert two files, rows not in order and REMOVE 1 COLUMN OF ID
def do_assertion_csv_tab_non_order(expected_obj, actual_obj)
  for i in (1..expected_obj.length - 1)
    expected_row = expected_obj[i].drop(1).to_s.split("\t")
    found = false
    for j in (1..actual_obj.length - 1)
      actual_row = actual_obj[j].drop(1).to_s.split("\t")
      if (expected_row == actual_row)
        found = true
        break
      end
    end
    assert(found, "Expected Record: [#{expected_obj[i].to_s}] is not included in reporting file")
  end
end

# Assert 2 values
def reg_compare sActual, regValue, isSpecialChar=false
  begin
    if !isSpecialChar
      sActual = sActual.strip
      regValue = regValue.strip.gsub("[", "\\[").gsub("]", "\\]").gsub("(", "\\(").gsub(")", "\\)").gsub(">", "\\>")
    end
  rescue StandardError => myStandardError
    puts "❌  ERROR #{myStandardError}"
    exit(1)
  end

  # put_log "\nsActual:#{sActual}, regValue:#{regValue}"
  if ((sActual.nil? and regValue.nil?) or (!sActual.nil? and sActual.empty? and !regValue.nil? and regValue.empty?))
    return true
  end

  if ((sActual.nil? and !regValue.nil?) or (!sActual.nil? and regValue.nil?))
    return false
  end

  if (!sActual.nil? and !sActual.empty?)
    sCookActual = sActual.gsub(/\n|\r/, " ")
    if (sCookActual == regValue or (isSpecialChar and sCookActual.include? regValue) or (!isSpecialChar and sCookActual =~ /^.*#{regValue}.*$/))
      return true
    end
  end

  return false
end

def do_assertion_json(expected_obj, actual_obj, options = {})
  # puts "\n\n actual_obj.class: #{actual_obj.class}"
  # puts "\n\n expected_obj.class: #{expected_obj.class}"

  if expected_obj.kind_of? Hash
    # if options['isIncludedAssertion'].nil? or options['isIncludedAssertion'] == false
    #   do_assertion(expected_obj.keys.size, actual_obj.keys.size)
    # end
    expected_obj.keys.each do |key|
      # puts "\n\n key: #{key}"
      # puts "\n\n value: #{expected_obj[key]}"
      # puts "\n\n value: #{actual_obj[key]}"
      if actual_obj[key].nil?
        raise "[%s] expected [%s] but actual value was nil." % [key, expected_obj[key].to_s]
      else
        do_assertion_json(expected_obj[key], actual_obj[key], options)
      end
    end
  elsif expected_obj.kind_of? Array
    if options['isIncludedAssertion'].nil? or options['isIncludedAssertion'] == false
      do_assertion_json(expected_obj.size, actual_obj.size)
    end
    for i in (0..expected_obj.length-1)
      do_assertion_json(expected_obj[i], actual_obj[i], options)
    end
  else
    begin
      assert_string_equal(expected_obj.to_s, actual_obj.to_s)
    rescue => e
      raise("Assert fail. \n\n Expected: '#{expected_obj}' \n\n Got: '#{actual_obj}'. Detail info: #{e.message}")
    end
  end
end

def assert_string_contain(expected, actual)
  unless (actual.to_s).include? (expected.to_s)
    raise ("*** ASSERTION ERROR: \nExpected: #{expected}. \nGot: #{actual}.")
  end
end

def assert_string_equal(expected, actual)
  if expected.to_s != actual.to_s
    raise ("*** ASSERTION ERROR: \nExpected: #{expected}. \nGot: #{actual}.")
  end
end

def assert_string_not_equal(expected, actual)
  if expected.to_s == actual.to_s
    raise ("*** ASSERTION ERROR: \nExpected: #{expected}. \nGot: #{actual}.")
  end
end
